#include<stdio.h>
typedef struct{
	unsigned long long d; int p;
}dan;
main (){
	unsigned long long x,s=0,st=0,i,j,pit[100],dd; dan niz[1000];
	unsigned n,q;
	scanf("%u%u",&n,&q);
	for(i=0;i<n;i++){
		scanf("%llu%d",&niz[i].d,&niz[i].p);
	}
	for(j=0;j<q;j++){
		scanf("%llu",&pit[j]);
	}
	for(i=0; i<q;i++){
		s=0;
		x=0;
		st=0;
		for(j=1;j<=pit[i];j++){
			if(j==niz[x].d){
				st+=niz[x].p;
				x++;
			}
			if(st>0){
				st-=1;
				s+=1;
			}
		}
		printf("%llu \n",s);
	}
}